using namespace std;
#include<iostream>
#include<fstream>
#include<vector>
#include<string>
#include<time.h>

#include<stdio.h>
#include<stdlib.h>
#include<myroot.h>
#include<histo.h>

#include<SetIni.h>    // include class containing initializations for M
extern SetIni inival;
#include<SetHisto.h>  // initialization of histograms
extern SetHisto inihis;

extern Int_t initiate();
int    CheckWIN32; // check inviroment

extern int   userInit();
extern int   userRun();
extern int   userEnd(); 



int main(int argc, char **argv)
{



// initiation
    Int_t initi=initiate();
    if (initi == 1)  {
     cout << "error in the initialization, read error file" << endl;
     return 1;
    }
// check inviroment
   CheckWIN32=0;
   if (getenv("RUNMCwin32")  != NULL ) CheckWIN32=1; // seems cygwin

// get PID of this process, and renice it
    pid_t mypid = getpid();
    cout << "RUNMC: PID OF THE PROCESS = " <<  mypid << endl;
    if (inival.Renice > 20) {inival.Renice=20;}
    if (inival.Renice < 0)  {inival.Renice=0;}
    char  renicePID[35];
    sprintf(renicePID,"renice %2d %8d", inival.Renice, mypid);
    cout << "RUNMC: "<< renicePID << endl;
    cout << "RUNMC: ";

// get seed for MC
    time_t curtime=time(NULL);      // get current time
    cout << "RUNMC: execution time     = " << ctime(&curtime);

     Int_t  SHOWCANVAS=1; // by deafault,  show canvas
                         // pop up second window with lumi info
    if (inihis.HistoNcurrent == 0 ||
        inihis.HistoOptions[1]==5 ||
        inihis.HistoOptions[9]== 0 ) { SHOWCANVAS=0; };

 // in case if you need to access the canvas
        if (inihis.HistoOptions[1]==6) SHOWCANVAS=2;


    // initiate pipe file
    char * RUNDIR; char PipeStop[500], PipeEvents[500];
    RUNDIR=getenv("RUNMC");
    strcpy(PipeEvents,RUNDIR);
    strcpy(PipeStop,RUNDIR);
//  cout << outpupipes << endl;
    strncat(PipeEvents, "/pipes/", strlen("/pipes/"));
    strncat(PipeEvents, inival.PipeName, strlen(inival.PipeName) );
    strncat(PipeEvents, ".event", strlen(".event") );
    strncat(PipeStop, "/pipes/", strlen("/pipes/"));
    strncat(PipeStop, inival.PipeName, strlen(inival.PipeName) );
    strncat(PipeStop, ".stop", strlen(".stop") );


 // output files
    char HISTroot[60], HEPEVTroot[60], RUNMCroot[60];
    cout << "RUNMC: output file: " <<  inival.MOutput  << endl;
    strncpy(HISTroot, "", 59);
    strncpy(HEPEVTroot, "", 59);
    strncpy(RUNMCroot, "", 59);
    strncat(HISTroot,inival.MOutput, strlen(inival.MOutput));
    strncat(HEPEVTroot,inival.MOutput, strlen(inival.MOutput));
    strncat(RUNMCroot,inival.MOutput, strlen(inival.MOutput));
    strncat(HISTroot, ".root", 5 );
    strncat(HEPEVTroot, ".htup", 5 );
    strncat(RUNMCroot, ".rtup", 5 );


// system files
    ofstream myout(PipeEvents, ios::out | ios::trunc);
    ifstream myin1(PipeStop, ios::in); //only check at the beginning
      if (!myout) {
    cout << "Cannot open system file " << PipeEvents << endl; return 1;};
       myout.close();

    if (!myin1) {
    cout << "Cannot open system file! " << PipeStop << endl;
    cout << "To be able to run without RunMC GUI, you should create this file and put 0" << endl;
    cout << "To stop this run without RunMC GUI, replace 0 by  1" << endl;
    return 1;};
    myin1 >> inival.Stop; myin1.close();
    if (inival.Stop == 1) { cout << PipeStop << " has 1, not 0 : stop this run" << endl; return 2; }

// root definitions
// gROOT->Reset();
   if (inihis.HistoOptions[5] < 4) { gROOT->SetStyle("Plain"); }


// inihis.HistoOptions[9]=1 -  histogram files
// inihis.HistoOptions[10]=1 - HEPEVT  files
// inihis.HistoOptions[11]=1 - RunMC   files
// output histograms
   if (inihis.HistoOptions[9] == 1) { f1 = new TFile(HISTroot,"recreate", "RunMC histograms");}
   Int_t kUPDATE = 5;
   Int_t kEVENTS=100; // how mane events - calculate later
   if (inihis.HistoOptions[0]==1) kUPDATE = 2; //update interval
   if (inihis.HistoOptions[0]==2) kUPDATE = 5; //update interval
   if (inihis.HistoOptions[0]==3) kUPDATE = 10; //update interval
   if (inihis.HistoOptions[0]==4) kUPDATE = 30; //update interval
   if (inihis.HistoOptions[0]==5) kUPDATE = 60; //do not upade


    TApplication* runmcApp=0;
   // run canvas
    if (SHOWCANVAS>0)  runmcApp = new TApplication("App", &argc, argv);


   Int_t xcan=inihis.HistoOptions[3];
   Int_t ycan=inihis.HistoOptions[4];
   Int_t  nshow=8; // show all histograms (up to 8 histograms for now)

//------------------- start showing canvas -----------------------------------------------
   if (SHOWCANVAS > 0 ) {  // if show canves
   c1 = new TCanvas("c1", "RunMC ROOT",xcan,ycan);
   c1->SetLineWidth(2);
   c1->SetTitle( "RunMC"  );  // put title
   if (inihis.HistoOptions[6]==2) {c1->SetLogx();}
   if (inihis.HistoOptions[7]==2) {c1->SetLogy();}

// some color options
   if (inihis.HistoOptions[5] < 4)  { c1->SetFillColor(0); };
   if (inihis.HistoOptions[5]==6) { // color  style markers
   c1->SetFrameFillColor(41);
   c1->SetGrid(); c1->SetLineWidth(2); c1->SetLineColor(kMagenta); c1->SetFillColor(41); }

if (inihis.HistoOptions[1]==1) {
// this make log scale to work for one histogram
//     if (inihis.HistoNcurrent == 1) {
//     c1->Divide(1,1,0.005,0.005); }
     if (inihis.HistoNcurrent == 2) {
     c1->Divide(1,2,0.005,0.005); }
     if (inihis.HistoNcurrent == 3) {
     c1->Divide(2,2,0.005,0.005); }
     if (inihis.HistoNcurrent == 4) {
     c1->Divide(2,2,0.005,0.005); }
     if (inihis.HistoNcurrent == 5) {
     c1->Divide(2,3,0.005,0.005); }
     if (inihis.HistoNcurrent == 6) {
     c1->Divide(2,3,0.005,0.005); }
     if (inihis.HistoNcurrent == 7) {
     c1->Divide(2,4,0.005,0.005); }
     if (inihis.HistoNcurrent >= 8) {
     c1->Divide(2,4,0.005,0.005); }
   }
   c1->Draw();

// define maximum number of shown histograms
   if (inihis.HistoOptions[1]==2) {
     nshow=1;
     c1->Divide(1,1,0.005,0.005); }
   if (inihis.HistoOptions[1]==3) {
     nshow=2;
     c1->Divide(1,2,0.005,0.005); }
   if (inihis.HistoOptions[1]==4) {
     nshow=4;
     c1->Divide(2,2,0.005,0.005); }
   if (inihis.HistoOptions[1]==5) {
     nshow=0; }

   gPad->SetLeftMargin(0.2);
   gPad->SetBottomMargin(0.25);
   if (inihis.HistoOptions[6]==2) {gPad->SetLogx();}
   if (inihis.HistoOptions[7]==2) {gPad->SetLogy();}
   c1->Update();

   } // end show canvas  defined


// ------------------- end showing canvas
// different styles
    char hmode[20];
    char hmode2D[20];
    char * OOP1="hist e";
    char * OOP2="ep";
    char * OOPD[10]={"LEGO","LEGO2","LEGO","SURF","SURF2Z","COL","COLZ","CONT0","ARR","BOX"};

   Float_t xmin=0; Float_t xmax=0; Int_t nbin=0;
   Float_t bin_size[500];

   if (inihis.HistoNcurrent >= 500) { cout << "Too many histograms!" << endl; return 3;}


   cout << "RunMC: the following order was set to show the histograms= "<< endl;
   cout << "       "<< OH[1] << "D " << OH[2] << "D " << OH[3] << "D " << OH[4] << "D ";
   cout << OH[5] << "D " << OH[6] << "D " << OH[7] << "D " << OH[8] << "D " << endl;
   cout << "RUNMC: total number of 1D histograms                 =" << inihis.HistoNcurrent1D << endl;
   cout << "       number of 1D histograms for events            =" << EventsP << endl;
   cout << "       number of 1D histograms for 1-particle density=" << SingleP << endl;
   cout << "       number of 1D histograms for 2-particle density=" << DoubleP << endl;

// create 1D histograms
   for  (Int_t i=1; i<=inihis.HistoNcurrent1D; i++ ) {
    cout <<"RUNMC: title of 1D histogram=" << i << "  " << NAMESA[i] << endl;
    xmin=xmin1D[i];
    xmax=xmax1D[i];
    nbin=nbin1D[i];
    bin_size[i]=(xmax-xmin)/(Float_t)nbin;
   hp[i]  = new TH1F(NAMESA[i],NAMESA[i],nbin,xmin,xmax);
   hp[i]->SetTitle( NAMESA[i] );
   hp[i]->SetLineStyle(1);
   hp[i]->SetFillColor(0);
   hp[i]->SetLineWidth(2);
   hp[i]->SetMarkerStyle(20);
   hp[i]->SetMarkerSize(0.3);
   hp[i]->Sumw2();
   if (inihis.HistoOptions[5]==1) { // color style lines
   hp[i]->SetFillColor(45);
   strcpy(hmode,OOP1);  };
   if (inihis.HistoOptions[5]==2) { // plain  style lines
   hp[i]->SetFillColor(0);
   strcpy(hmode,OOP1); };
   if (inihis.HistoOptions[5]==3) { // plain  style markers
   hp[i]->SetFillColor(0);
   hp[i]->SetMarkerStyle(20); hp[i]->SetMarkerSize(1.0);  strcpy(hmode,OOP2); };
   if (inihis.HistoOptions[5]==4) { // color  style markers
   hp[i]->SetFillColor(0); hp[i]->SetMarkerStyle(20); hp[i]->SetMarkerSize(1.0);
   strcpy(hmode,OOP2);; };
   if (inihis.HistoOptions[5]==5) { // color  style markers
   hp[i]->SetFillColor(33); hp[i]->SetMarkerStyle(20); hp[i]->SetMarkerSize(1.0);
   hp[i]->SetMarkerColor(kBlue);
   hp[i]->SetMarkerStyle(20); strcpy(hmode,OOP2); };
   if (inihis.HistoOptions[5]==6) { // color  style markers
   hp[i]->SetFillColor(kBlue);
   strcpy(hmode,OOP1);
   };
// set drawing options. This can be changed latter by a user
   DrawOption1D[i] = new char[strlen(hmode)];
   strcpy(DrawOption1D[i],hmode);
// set statistics
   if (inihis.HistoOptions[2]==1) {hp[i]->SetStats(1);}
   if (inihis.HistoOptions[2]==2) {hp[i]->SetStats(0);}
   }

   cout << "RUNMC: number of 2D histograms                       =" << inihis.HistoNcurrent2D << endl;
// create 2D histograms
  for  (Int_t i=1; i<=inihis.HistoNcurrent2D; i++ ) {
  cout <<"RUNMC: title of 2D histogram=" << i << "  " << NAMESA3[i] << " build from ";
  cout << NAMESA1[i] << " and " << NAMESA2[i] <<  endl;
  cout << "       number of 2D histograms for events            =" << EventsP1 << " and " << EventsP2 << endl;
  cout << "       number of 2D histograms for 1-particle density=" << SingleP1 << " and " << SingleP2 << endl;
  cout << "       number of 2D histograms for 2-particle density=" << DoubleP1 << " and " << DoubleP2 << endl;
  hp2D[i]  = new TH2F(NAMESA3[i],NAMESA3[i],n1bin2D[i],x1min2D[i],x1max2D[i],n2bin2D[i],x2min2D[i],x2max2D[i]);
  hp2D[i]->SetTitle( NAMESA[i] );
  hp2D[i]->SetLineStyle(1);
  hp2D[i]->SetFillColor(0);
  hp2D[i]->SetLineWidth(2);
  hp2D[i]->SetMarkerStyle(20);
  hp2D[i]->SetMarkerSize(0.3);
  hp2D[i]->SetTitle( NAMESA3[i] );
  hp2D[i]->Sumw2();
// draw options - user can change this
  DrawOption2D[i] = new char[strlen(OOPD[inihis.HistoOptions[12]])];
  strcpy(DrawOption2D[i],OOPD[inihis.HistoOptions[12]]);
  }

// get 2D styles - only for RunMC
   strcpy(hmode2D,OOPD[inihis.HistoOptions[12]]);


   Int_t n=0; int nev=0; 


   Int_t useriniterror=userInit();
   if (useriniterror !=0 ) { cout << "userInit() returns error!" << endl;  return 1; } 

// user initialisation
    cout << "RUNMC: Total number of events to process = " << inival.Nevents  << endl;


// make timer for average time per event
    TStopwatch RUNMCtimer;
    RUNMCtimer.Start();
    Double_t RUNMCrealTime=0;
    Double_t RUNMCcpuTime=0;
    Int_t    EventsFor5sec=1;
    Int_t    NTimeCheck=50000; // check average time after this number
    Int_t    NtimeC=0;

//   Create a timer object to benchmark this loop
   TStopwatch timer;
   timer.Start(); Int_t itime=0; Double_t tnew = 0;


// start running
   while(n<inival.Nevents) {
   n++;
   // user run over events
   Int_t userrunerror=userRun();
   if (userrunerror !=0 ) { cout << "userRun() returns error!" << endl;  return 2; }

// terminate
   if (inival.Stop == 1) {
   cout << "RUNMC: Terminate the job, since inival.Stop is" << inival.Stop << endl;
   goto stopend;}

    nev++; // count events which look OK

   if (n == 0 || (n >= NTimeCheck && (n%NTimeCheck) == 0)  ) {
   NtimeC=0;  RUNMCtimer.Start(); }
   NtimeC++;
// check average time
   if (NtimeC == 20) {
   RUNMCtimer.Stop();
   RUNMCrealTime = RUNMCtimer.RealTime()/ 20. ;
   RUNMCcpuTime = timer.CpuTime() / 20. ;
     cout << "RUNMC: average CPU  time for 1 event = " << RUNMCcpuTime;
     cout << " after " <<  n << " events" << endl;
     cout << "RUNMC: average REAL time for 1 event = " << RUNMCrealTime;
     cout << " after " <<  n << " events" << endl;
     EventsFor5sec=(Int_t)(5./RUNMCrealTime);
     kEVENTS=(Int_t)( (Float_t)kUPDATE / RUNMCrealTime);
     //  cout << "No of events necessary for 5 sec " << EventsFor5sec << endl;
     if (3*EventsFor5sec < 2) {
        cout << "Looks like your program or computer is too slow!" << cout;
        cout << "RUNMC takes " << RUNMCrealTime << " to process a single event!" << cout;
        cout << "RUNMC will try to terminate the job " << endl;
        goto stopend; };
    };

// ouput
        if (n<=10 &&
        n<=100 && (n%10) == 0 ||
        n<=1000 && (n%100) == 0  ||
        n>=1000 && (n%1000) == 0. ) {
        tnew = timer.RealTime();
        timer.Continue();
        itime = (Int_t)tnew;
        cout << "No events= " << n << " time passed=" << itime << " s" << endl; };

// output to system file: number of events and stop signal
        if (
        (n<=100 && (n%10) == 0) ||
        (n>100 && (n%EventsFor5sec) == 0)    ) {
// check termination
        ifstream myin(PipeStop, ios::in);
        if (!myin) {
            cout << "Cannot open system pipe file: " << PipeStop << endl;
            cout << "Since it was removed, RunMC assumes that you want to terminate this run"  << endl;
            cout << "All histograms should be saved!" << endl;
            goto stopend;
        } else { myin >> inival.Stop; } myin.close();


// write into
        ofstream myout(PipeEvents, ios::out | ios::trunc);
        myout << n << " " << mypid << endl;   myout.close();  }  // put number of events and pid number

//  fill histograms for event characteristics
      if (inihis.HistoOptions[9] == 1) { // start filling histograms

// back to histogram files
        f1->cd();


// start updatting
      if ( n && (n%kEVENTS) == 0 && SHOWCANVAS > 0  ) {
           Int_t ncoun1=0; Int_t ncoun2=0;
           for  (Int_t i=1; i<=inihis.HistoNcurrent; i++ ) {
           if (i<=nshow) {
           c1->cd( i );
           if (OH[i] == 1) { ncoun1++;    hp[ncoun1]->Draw( DrawOption1D[ncoun1] );  };
           if (OH[i] == 2) { ncoun2++;  hp2D[ncoun2]->Draw( DrawOption2D[ncoun2] );  };
           c1->Update();
           }; };
       if (gSystem->ProcessEvents()) break;
       }  // end show canvas  defined

       } // End filling of histograms ------------------------------------------------------

      } // end loop over events

 stopend:

// write final number of processed events
     ofstream myout1(PipeEvents, ios::out | ios::trunc);
     myout1 << n << endl;    // put number of events
     myout1.close();

// replot again all histograms
         Int_t ncoun1=0; Int_t ncoun2=0;
         for  (Int_t i=1; i<=inihis.HistoNcurrent; i++ ) {
         if (i<=nshow && SHOWCANVAS > 0) {
         c1->cd( i );
         if (OH[i] == 1) { ncoun1++;    hp[ncoun1]->Draw( DrawOption1D[ncoun1] );  };
         if (OH[i] == 2) { ncoun2++;  hp2D[ncoun2]->Draw( DrawOption2D[ncoun2] );  };
         c1->Update();
         }; };


// if this is 2D histogram, put axis (only for single histogram!)
      if (inihis.HistoNcurrent2D == 1 && inihis.HistoNcurrent1D == 0) {
         c1->cd( 1 );
         TAxis *axis1 = hp2D[1]->GetXaxis();
         TAxis *axis2 = hp2D[1]->GetYaxis();
         axis1->SetTitleSize(0.07); axis2->SetTitleSize(0.07);
         axis1->SetTitleOffset(1.0);
         axis1->SetTitle( NAMESA1[1]  );
         axis2->SetTitle( NAMESA2[1]  );
         axis1->Draw("same");
         axis2->Draw("same");
         if (SHOWCANVAS > 0) c1->Update();
       } // end

   // user termination
   Int_t userenderror=userEnd();
   if (userenderror !=0 ) { cout << "userEnd() returns error!" << endl;  return 3; }

// start App
    if (SHOWCANVAS>0) runmcApp->Run(kTRUE);

// stop timer
    timer.Stop();

// write histograms into file and close
   if (inihis.HistoOptions[9] == 1) {
   f1->cd(); f1->Write(); f1->Close(); } // close file


// clean temporary files if there are some
     struct stat buf;
     int itmp = stat ("runmc.tmp",&buf);
     if (itmp == 0) remove("runmc.tmp");

  return 0;
}
